/*
 * Generated by MyEclipse Struts
 * Template path: templates/java/JavaClass.vtl
 */
package com.asf.cred.struts.action;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.upload.FormFile;
import org.hibernate.exception.SQLGrammarException;

import com.asf.cred.security.SessionHandler;
import com.asf.cred.struts.form.AbmForm;
import com.asf.cred.struts.form.ArchivoForm;
import com.asf.hibernate.mapping.Claves;
import com.asf.security.BusinessPersistance;
import com.asf.struts.action.AbmAction;
import com.asf.struts.form.ListForm;
import com.asf.util.CastRequestHelper;
import com.civitas.hibernate.persona.Archivo;
import com.civitas.hibernate.persona.Persona;
import com.civitas.util.PDFMerger;
import com.nirven.creditos.hibernate.ArchivoLegajoDigital;
import com.nirven.creditos.hibernate.DocumentoJudicial;
import com.nirven.creditos.hibernate.LegajoDigital;
import com.nirven.expedientes.persistencia.TipoDeArchivo;

public class ArchivoAction extends AbmAction {

	@Override
	public ActionForward list(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		/**
		 * esto es exacto lo que hace abmform
		 */
		AbmForm oAForm = null;
		ListForm oLForm = null;
		String strFilter = "";
		boolean bolFilter = false;
		if (form == null) {
			oLForm = new ListForm();
		} else {
			if (form instanceof AbmForm) {
				oAForm = (AbmForm) form;
				oLForm = new ListForm();
				oLForm.setEntityName(oAForm.getEntityName());
				bolFilter = oAForm.getFilter();
			} else {
				oLForm = (ListForm) form;
			}
		}
		if (oLForm.getEntityName().equals("")) {
			oLForm.setEntityName(request.getParameter("entityName"));
		}
		if (bolFilter) {
			strFilter = setFilter(request, oAForm);
		}
		BusinessPersistance bp = SessionHandler.getCurrentSessionHandler().getBusinessPersistance();
		List<Archivo> oList = new ArrayList<Archivo>();
		if (bolFilter) {
			if (strFilter != null && !strFilter.equals("")) {
				try {
					oList = bp.getByFilter("FROM " + Archivo.class.getCanonicalName() + " x " + strFilter);
				} catch (SQLGrammarException e) {
					request.getSession().setAttribute("paramName", null);
					request.getSession().setAttribute("paramComp", null);
					request.getSession().setAttribute("paramValue", null);
				}
			}
		} else {
			oList = bp.createQuery("from " + Archivo.class.getCanonicalName()).list();
		}
		/**
		 * si la lista no esta vacia la ordeno
		 */
		if (!oList.isEmpty()) {
			Collections.sort(oList);
			for (int i = 0; i < oList.size(); i++) {
				Archivo archivo = oList.get(i);
				if (archivo.getOrden() == null || archivo.getOrden().longValue() == 0l) {
					archivo.setOrden(new Long(i + 1));
					bp.saveOrUpdate(archivo);
				}
			}
		}
		/**
		 * continua AbmForm
		 */
		oLForm.setResult(oList);
		request.setAttribute("ListResult", oLForm);
		return mapping.findForward(oLForm.getEntityName() + "List");

	}

	@Override
	public ActionForward save(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		BusinessPersistance oBp = SessionHandler.getCurrentSessionHandler().getBusinessPersistance();
		// TODO: Realizar la validación del campo TipoDeArchivo
		ArchivoForm archivoForm = (ArchivoForm) form;
		Archivo archivo = (Archivo) archivoForm.getEntity();
		FormFile theFile = archivoForm.getTheFile();
		if (!isCancelled(request)) {
			if (theFile.getFileSize() != 0) {
				archivo.setMimetype(theFile.getContentType());
				archivo.setNombre(theFile.getFileName());
				archivo.setOrden(buscarOrdenMaximo(archivo.getPersona().getId()) + 1);

				byte[] fileData = theFile.getFileData();
				// guarda los datos del fichero
				ByteArrayOutputStream baos = new ByteArrayOutputStream();
				InputStream stream = theFile.getInputStream();
				byte[] buffer = new byte[8192];
				int bytesLeidos = 0;
				while ((bytesLeidos = stream.read(buffer, 0, 8192)) != -1) {
					baos.write(buffer, 0, bytesLeidos);
				}
				archivo.setArchivo(baos.toByteArray());

			} else if (archivo.getId() != 0) {
				/**
				 * recupero datos desde la base de datos y descarto modificaciones al archivo
				 */
				Archivo a = (Archivo) oBp.getById(Archivo.class, archivo.getId());
				archivo.setMimetype(a.getMimetype());
				archivo.setNombre(a.getNombre());
				archivo.setArchivo(a.getArchivo());
				oBp.getCurrentSession().evict(a);
			}
			if (!archivo.validate()) {
				ActionMessages actionMessages = new ActionMessages();
				if (archivo.getArchivo() == null || archivo.getArchivo().length == 0) {
					actionMessages.add("documentacion.save.archivo.error",
							new ActionMessage("documentacion.save.archivo.error", "documentacion.save.archivo.error"));
				}
				saveErrors(request, actionMessages);
				return mapping.findForward("Archivo");
			} else if (archivo.getArchivoRepo().getIdTipoDeArchivo() == null
					|| archivo.getArchivoRepo().getIdTipoDeArchivo() == 0) {

				ActionMessages actionMessages = new ActionMessages();
				actionMessages.add("documentacion.save.tipoDeDocumento.error", new ActionMessage(
						"documentacion.save.tipoDeDocumento.error", "documentacion.save.tipoDeDocumento.error"));
				saveErrors(request, actionMessages);
				return mapping.findForward("Archivo");
			}
			if (archivo.getId() != null && archivo.getId().longValue() == 0l) {
				archivo.setId(null);
			}

			if (archivo.getId() == null) {

				archivo.setPersona((Persona) oBp.getById(Persona.class, archivo.getPersona().getId()));

				String descripcion = "Descripcion: " + archivo.getDescripcion() + ";" + "Persona: "
						+ archivo.getPersona().getNomb12() + ";" + "CUIT: " + archivo.getPersona().getCuil12Str();
				archivo.setDescripcion(descripcion);
			}

			oBp.saveOrUpdate(archivo);
		}
		request.setAttribute("archivoForm", form);
		return list(mapping, form, request, response);
	}

	public ActionForward descargar(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		String tipo = (String) request.getParameter("tipo");
		String id = (String) request.getParameter("id");
		OutputStream salida = response.getOutputStream();
		BusinessPersistance oBp = SessionHandler.getCurrentSessionHandler().getBusinessPersistance();
		if (tipo != null && tipo.equals("documentoJudicial")) {
			DocumentoJudicial dj = (DocumentoJudicial) oBp.getById(DocumentoJudicial.class, new Long(id));
			response.setContentType(dj.getMimetype());
			response.setHeader("Content-Disposition", "attachment;filename=\"" + dj.getNombre() + "\"");
			salida.write(dj.getArchivo());
		} else {
			Archivo a = (Archivo) oBp.getById(Archivo.class, new Long(id));
			response.setContentType(a.getMimetype());
			response.setHeader("Content-Disposition", "attachment;filename=\"" + a.getNombre() + "\"");
			salida.write(a.getArchivo());
		}
		salida.flush();
		salida.close();
		return null;
	}

	public ActionForward ver(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		String id = (String) request.getParameter("id");
		OutputStream salida = response.getOutputStream();
		BusinessPersistance oBp = SessionHandler.getCurrentSessionHandler().getBusinessPersistance();
		Archivo a = (Archivo) oBp.getById(Archivo.class, new Long(id));
		salida.write(a.getArchivo());
		salida.flush();
		salida.close();
		return null;
	}

	public ActionForward legajoDigitalPrintProfile(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		OutputStream salida = response.getOutputStream();
		BusinessPersistance oBp = SessionHandler.getCurrentSessionHandler().getBusinessPersistance();
		LegajoDigital legajoDigital = (LegajoDigital) oBp.getById(LegajoDigital.class,
				CastRequestHelper.toLong("legajoDigital_id", request));
		if (legajoDigital.getArchivo() != null) {
			salida.write(legajoDigital.getArchivo().getArchivo());
			salida.flush();
			salida.close();
		}
		return null;
	}

	public ActionForward legajoDigitalDownload(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		OutputStream salida = response.getOutputStream();
		BusinessPersistance oBp = SessionHandler.getCurrentSessionHandler().getBusinessPersistance();
		String id = (String) request.getParameter("id");
		ArchivoLegajoDigital a = (ArchivoLegajoDigital) oBp.getById(ArchivoLegajoDigital.class,
				CastRequestHelper.toLong("id", request));

		response.setContentType(a.getArchivo().getMimetype());
		response.setHeader("Content-Disposition", "attachment;filename=\"" + a.getArchivo().getNombre() + "\"");
		salida.write(a.getArchivo().getArchivo());
		return null;

	}

	public ActionForward legajoDigitalDownloadAll(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		BusinessPersistance bp = SessionHandler.getCurrentSessionHandler().getBusinessPersistance();
		TreeMap<Integer, ArchivoLegajoDigital> listContenido = new TreeMap<Integer, ArchivoLegajoDigital>();
		String id = (String) request.getParameter("id");
		String[] idsOp = (id != null && !id.isEmpty() ? id.toString().split(",") : null);
		String nombreArchivo = "";
		if (idsOp != null && idsOp.length > 0) {
			for (String id_ : idsOp) {
				ArchivoLegajoDigital arLgDi = (ArchivoLegajoDigital) bp.getById(ArchivoLegajoDigital.class,
						new Long(id_));
				nombreArchivo = nombreArchivo.isEmpty() ? arLgDi.getLegajoDigital().getNumeroLegajo() : nombreArchivo;
				listContenido.put(arLgDi.getOrden(), arLgDi);
			}
		}
		OutputStream salida = response.getOutputStream();
		List<InputStream> pdfs = new ArrayList<>();
		ArchivoLegajoDigital arLgDi;
		for (Map.Entry<Integer, ArchivoLegajoDigital> item : listContenido.entrySet()) {
			arLgDi = item.getValue();
			if ("application/pdf".equalsIgnoreCase(arLgDi.getArchivo().getMimetype())
					|| arLgDi.getArchivo().getNombre().toLowerCase().endsWith(".pdf")) {
				pdfs.add(new ByteArrayInputStream(arLgDi.getArchivo().getArchivo()));
			}
		}
		response.setContentType("application/pdf");
		response.setHeader("Content-Disposition", "attachment;filename=\"" + nombreArchivo + ".pdf\"");
		PDFMerger.mergePdfFilesUnequalPageSize(pdfs, salida);
		return null;
	}

	public ActionForward subir(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		BusinessPersistance bp = SessionHandler.getCurrentSessionHandler().getBusinessPersistance();
		Long id = Long.parseLong(request.getParameter("id"));
		Archivo archivo = (Archivo) bp.getById(Archivo.class, id);
		/**
		 * si existe un registro con el nuevo orden lo bajo
		 */
		bp.begin();
		try {
			String consulta = "select a from " + Archivo.class.getCanonicalName()
					+ " a where a.persona.id = :idpersona and a.orden = :orden";
			Archivo siguiente = (Archivo) bp.createQuery(consulta)
					.setParameter("idpersona", archivo.getPersona().getId())
					.setParameter("orden", archivo.getOrden() + 1).uniqueResult();
			if (!(siguiente == null)) {
				siguiente.setOrden(siguiente.getOrden() - 1);
				bp.saveOrUpdate(siguiente);
			}
			if (!(buscarOrdenMaximo(archivo.getPersona().getId()) == archivo.getOrden())) {
				archivo.setOrden(archivo.getOrden() + 1);
				bp.saveOrUpdate(archivo);
			}
			bp.commit();
		} catch (Exception e) {
			bp.rollback();
		}
		return list(mapping, form, request, response);
	}

	public ActionForward bajar(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		BusinessPersistance bp = SessionHandler.getCurrentSessionHandler().getBusinessPersistance();
		Long id = Long.parseLong(request.getParameter("id"));
		Archivo archivo = (Archivo) bp.getById(Archivo.class, id);
		/**
		 * si existe un registro con el nuevo orden lo bajo
		 */
		bp.begin();
		try {
			String consulta = "select a from " + Archivo.class.getCanonicalName()
					+ " a where a.persona.id = :idpersona and a.orden = :orden";
			Archivo anterior = (Archivo) bp.createQuery(consulta)
					.setParameter("idpersona", archivo.getPersona().getId())
					.setParameter("orden", archivo.getOrden() - 1).uniqueResult();
			if (!(anterior == null)) {
				anterior.setOrden(anterior.getOrden() + 1);
				bp.saveOrUpdate(anterior);
			}
			if (!(archivo.getOrden() == 1)) {
				archivo.setOrden(archivo.getOrden() - 1);
				bp.saveOrUpdate(archivo);
			}
			bp.commit();
		} catch (Exception e) {
			bp.rollback();
		}
		return list(mapping, form, request, response);
	}

	private long buscarOrdenMaximo(Long idpersona) {
		BusinessPersistance bp = SessionHandler.getCurrentSessionHandler().getBusinessPersistance();
		String consulta = "select max(orden) from archivoJoin where idPersona = :idpersona";
		Number ordenMaximo = (Number) bp.createSQLQuery(consulta).setLong("idpersona", idpersona).uniqueResult();
		ordenMaximo = ordenMaximo == null ? 0 : ordenMaximo;
		return ordenMaximo.longValue();
	}

	public ActionForward legajoDigital(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		BusinessPersistance bp = SessionHandler.getCurrentSessionHandler().getBusinessPersistance();
		ArchivoForm archivoForm = (ArchivoForm) form;
		com.nirven.expedientes.persistencia.Archivo a = new com.nirven.expedientes.persistencia.Archivo();
		ArchivoLegajoDigital e = new ArchivoLegajoDigital();
		FormFile theFile = archivoForm.getTheFile();
		boolean valid = true;

		if (!isCancelled(request)) {

			ActionMessages actionMessages = new ActionMessages();

			Long eid = CastRequestHelper.toLong("id", request);
			Integer tipo = CastRequestHelper.toInteger("tipo", request);
			Long idTipoDeArchivo = CastRequestHelper.toLong("entity_archivoRepo_idTipoDeArchivoAccess", request);
			String descripcion = CastRequestHelper.toString("archivo_descripcion", request);
			Long legajoDigitalId = CastRequestHelper.toLong("legajoDigital_id", request);
			Date desde = CastRequestHelper.toDate("desde", request);
			Date hasta = CastRequestHelper.toDate("hasta", request);
			boolean visualizar = CastRequestHelper.toBool("visualizar", request);
			String allowVisualizar = CastRequestHelper.toString("ArchivoLegajoDigitalVisualizar", request);

			if (tipo <= 0 || tipo == null) {
				valid = false;
				actionMessages.add("archivo.error.tipoArchivo",
						new ActionMessage("archivo.error.tipoArchivo", "archivo.error.tipoArchivo"));
			}

			if (eid != null) {
				// Se guarda una edición
				e = (ArchivoLegajoDigital) bp.getById(ArchivoLegajoDigital.class, eid);
				a = (com.nirven.expedientes.persistencia.Archivo) bp
						.getById(com.nirven.expedientes.persistencia.Archivo.class, e.getArchivo().getId());

			} else {
				if (theFile.getFileSize() == 0) {
					valid = false;
					actionMessages.add("archivo.error.archivo",
							new ActionMessage("archivo.error.archivo", "archivo.error.archivo"));
				} else {
					a.setMimetype(theFile.getContentType());
					a.setNombre(theFile.getFileName());

					byte[] fileData = theFile.getFileData();
					ByteArrayOutputStream baos = new ByteArrayOutputStream();
					InputStream stream = theFile.getInputStream();

					byte[] buffer = new byte[8192];
					int bytesRead = 0;
					while ((bytesRead = stream.read(buffer, 0, 8192)) != -1) {
						baos.write(buffer, 0, bytesRead);
					}

					a.setArchivo(baos.toByteArray());
					e.setOrden(e.getNextOrderValue(legajoDigitalId, tipo));
				}
			}

			if (valid) {

				a.setDescripcion(descripcion);
				a.setFecha(new Date());
				if (idTipoDeArchivo != null && idTipoDeArchivo >= 0) {
					a.setIdTipoDeArchivo(idTipoDeArchivo);
				}
				Claves usuario = (Claves) bp.getById(Claves.class,
						SessionHandler.getCurrentSessionHandler().getCurrentUser());
				a.setUsuario(usuario);
				bp.save(a);

				LegajoDigital legajoDigital = new LegajoDigital();
				legajoDigital = (LegajoDigital) bp.getById(LegajoDigital.class, legajoDigitalId);

				e.setArchivo(a);
				e.setLegajoDigital(legajoDigital);
				e.setTipo(tipo);
				e.setDesde(desde);
				e.setHasta(hasta);
				if ("allow".equals(allowVisualizar)) {
					e.setVisualizar(visualizar);
				}
				bp.save(e);

				response.getWriter().print("<done></done>");
				response.flushBuffer();
			} else {
				saveErrors(request, actionMessages);
				return mapping.findForward("ArchivoLegajoDigital");
			}

		} else {
			response.getWriter().print("<done></done>");
			response.flushBuffer();
		}

		request.setAttribute("ArchivoForm", form);
		return mapping.findForward("ArchivoLegajoDigital");
	}

	public ActionForward legajoDigitalForm(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		return mapping.findForward("ArchivoLegajoDigital");
	}

	public ActionForward legajoDigitalFoto(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		BusinessPersistance bp = SessionHandler.getCurrentSessionHandler().getBusinessPersistance();
		ArchivoForm archivoForm = (ArchivoForm) form;
		com.nirven.expedientes.persistencia.Archivo a = new com.nirven.expedientes.persistencia.Archivo();
		FormFile theFile = archivoForm.getTheFile();

		if (!isCancelled(request)) {
			if (theFile.getFileSize() != 0) {
				a.setMimetype(theFile.getContentType());
				a.setNombre(theFile.getFileName());

				byte[] fileData = theFile.getFileData();
				ByteArrayOutputStream baos = new ByteArrayOutputStream();
				InputStream stream = theFile.getInputStream();

				byte[] buffer = new byte[8192];
				int bytesRead = 0;
				while ((bytesRead = stream.read(buffer, 0, 8192)) != -1) {
					baos.write(buffer, 0, bytesRead);
				}

				a.setArchivo(baos.toByteArray());
				a.setFecha(new Date());
				a.setIdTipoDeArchivo(new Long(-1));
				TipoDeArchivo tipoDeArchivo = (TipoDeArchivo) bp.getById(TipoDeArchivo.class, new Long(-1));
				a.setTipoDeArchivo(tipoDeArchivo);
				Claves usuario = (Claves) bp.getById(Claves.class,
						SessionHandler.getCurrentSessionHandler().getCurrentUser());
				a.setUsuario(usuario);
				bp.save(a);
				LegajoDigital legajoDigital = new LegajoDigital();
				legajoDigital = (LegajoDigital) bp.getById(LegajoDigital.class,
						CastRequestHelper.toLong("legajoDigital_id", request));
				legajoDigital.setArchivo(a);
				bp.save(legajoDigital);
				response.getWriter().print("<done></done>");
				response.flushBuffer();

			} else {
				ActionMessages actionMessages = new ActionMessages();
				actionMessages.add("documentacion.save.archivo.error",
						new ActionMessage("documentacion.save.archivo.error", "documentacion.save.archivo.error"));
				saveErrors(request, actionMessages);
				return mapping.findForward("LegajoDigitalFoto");
			}
		} else {
			// TODO: Is Cancelled
		}

		request.setAttribute("ArchivoForm", form);
		return mapping.findForward("LegajoDigitalFoto");
	}

	public ActionForward legajoDigitalFotoForm(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		return mapping.findForward("LegajoDigitalFoto");
	}
}
